## tuned 2.24.0

=== Makefile ===
NAME = tuned
# set to devel for nightly GIT snapshot
BUILD = release
# which config to use in mock-build target
MOCK_CONFIG = rhel-7-x86_64
# scratch-build for triggering Jenkins
SCRATCH_BUILD_TARGET = rhel-7.5-candidate
VERSION = $(shell awk '/^Version:/ {print $$2}' tuned.spec)
PRERELEASENUM = $(shell awk '/^\s*%global prereleasenum/ {print $$3}' tuned.spec)
ifneq ($(strip $(PRERELEASENUM)),)
	PRERELEASE = -rc.$(PRERELEASENUM)
endif
GIT_DATE = $(shell date +'%Y%m%d')
ifeq ($(BUILD), release)
	RPM_ARGS += --without snapshot
	MOCK_ARGS += --without=snapshot
	RPM_VERSION = $(NAME)-$(VERSION)-1
else
	RPM_ARGS += --with snapshot
	MOCK_ARGS += --with=snapshot
	GIT_SHORT_COMMIT = $(shell git rev-parse --short=8 --verify HEAD)
	GIT_SUFFIX = $(GIT_DATE)git$(GIT_SHORT_COMMIT)
	GIT_PSUFFIX = .$(GIT_SUFFIX)
	RPM_VERSION = $(NAME)-$(VERSION)-1$(GIT_PSUFFIX)
endif
PKG_CONFIG = pkg-config
UNITDIR_FALLBACK = /usr/lib/systemd/system
UNITDIR_DETECT = $(shell $(PKG_CONFIG) systemd --variable systemdsystemunitdir || rpm --eval '%{_unitdir}' 2>/dev/null || echo $(UNITDIR_FALLBACK))
UNITDIR = $(UNITDIR_DETECT:%{_unitdir}=$(UNITDIR_FALLBACK))
TMPFILESDIR_FALLBACK = /usr/lib/tmpfiles.d
TMPFILESDIR_DETECT = $(shell $(PKG_CONFIG) systemd --variable tmpfilesdir || rpm --eval '%{_tmpfilesdir}' 2>/dev/null || echo $(TMPFILESDIR_FALLBACK))
TMPFILESDIR = $(TMPFILESDIR_DETECT:%{_tmpfilesdir}=$(TMPFILESDIR_FALLBACK))
VERSIONED_NAME = $(NAME)-$(VERSION)$(PRERELEASE)$(GIT_PSUFFIX)

export SYSCONFDIR = /etc
export DATADIR = /usr/share
export DOCDIR = $(DATADIR)/doc/$(NAME)
PYTHON = /usr/bin/python3
PYLINT = pylint-3
ifeq ($(PYTHON),python2)
PYLINT = pylint-2
endif
SHEBANG_REWRITE_REGEX= '1s|^\#!/usr/bin/\<python3\>|\#!$(PYTHON)|'
PYTHON_SITELIB = $(shell $(PYTHON) -c 'from sysconfig import get_path; print(get_path("purelib"));')
ifeq ($(PYTHON_SITELIB),)
$(error Failed to determine python library directory)
endif
KERNELINSTALLHOOKDIR = /usr/lib/kernel/install.d
TUNED_SYSTEM_DIR = /usr/lib/tuned
TUNED_PROFILES_DIR = $(TUNED_SYSTEM_DIR)/profiles
TUNED_RECOMMEND_DIR = $(TUNED_SYSTEM_DIR)/recommend.d
TUNED_USER_RECOMMEND_DIR = $(SYSCONFDIR)/tuned/recommend.d
BASH_COMPLETIONS = $(DATADIR)/bash-completion/completions

copy_executable = install -Dm 0755 $(1) $(2)
rewrite_shebang = sed -i -r -e $(SHEBANG_REWRITE_REGEX) $(1)
restore_timestamp = touch -r $(1) $(2)
install_python_script = $(call copy_executable,$(1),$(2)) \
	&& $(call rewrite_shebang,$(2)) && $(call restore_timestamp,$(1),$(2));

release-dir:
	mkdir -p $(VERSIONED_NAME)

release-cp: release-dir
	cp -a AUTHORS COPYING INSTALL README.md $(VERSIONED_NAME)

	cp -a tuned.py tuned.spec tuned.service tuned.tmpfiles Makefile tuned-adm.py \
		tuned-adm.bash dbus.conf recommend.conf tuned-main.conf 00_tuned \
		92-tuned.install bootcmdline modules.conf com.redhat.tuned.policy \
		tuned-gui.py tuned-gui.glade tuned-ppd.py \
		tuned-gui.desktop functions $(VERSIONED_NAME)
	cp -a doc experiments libexec man profiles systemtap tuned contrib icons \
		tests $(VERSIONED_NAME)

archive: clean release-cp
	tar czf $(VERSIONED_NAME).tar.gz $(VERSIONED_NAME)

rpm-build-dir:
	mkdir rpm-build-dir

srpm: archive rpm-build-dir
	rpmbuild --define "_sourcedir `pwd`/rpm-build-dir" --define "_srcrpmdir `pwd`/rpm-build-dir" \
		--define "_specdir `pwd`/rpm-build-dir" --nodeps $(RPM_ARGS) -ts $(VERSIONED_NAME).tar.gz

rpm: archive rpm-build-dir
	rpmbuild --define "_sourcedir `pwd`/rpm-build-dir" --define "_srcrpmdir `pwd`/rpm-build-dir" \
		--define "_specdir `pwd`/rpm-build-dir" --nodeps $(RPM_ARGS) -tb $(VERSIONED_NAME).tar.gz

clean-mock-result-dir:
	rm -f mock-result-dir/*

mock-result-dir:
	mkdir mock-result-dir

# delete RPM files older than cca. one week if total space occupied is more than 5 MB
tidy-mock-result-dir: mock-result-dir
	if [ `du -bs mock-result-dir | tail -n 1 | cut -f1` -gt 5000000 ]; then \
		rm -f `find mock-result-dir -name '*.rpm' -mtime +7`; \
	fi

mock-build: srpm
	mock -r $(MOCK_CONFIG) $(MOCK_ARGS) --resultdir=`pwd`/mock-result-dir `ls rpm-build-dir/*$(RPM_VERSION).*.src.rpm | head -n 1`&& \
	rm -f mock-result-dir/*.log

mock-devel-build: srpm
	mock -r $(MOCK_CONFIG) --with=snapshot \
		--define "git_short_commit `if [ -n \"$(GIT_SHORT_COMMIT)\" ]; then echo $(GIT_SHORT_COMMIT); else git rev-parse --short=8 --verify HEAD; fi`" \
		--resultdir=`pwd`/mock-result-dir `ls rpm-build-dir/*$(RPM_VERSION).*.src.rpm | head -n 1` && \
	rm -f mock-result-dir/*.log

createrepo: mock-devel-build
	createrepo mock-result-dir

# scratch build to triggering Jenkins
scratch-build: mock-devel-build
	brew build --scratch --nowait $(SCRATCH_BUILD_TARGET) `ls mock-result-dir/*$(GIT_DATE)git*.*.src.rpm | head -n 1`

nightly: tidy-mock-result-dir createrepo scratch-build
	rsync -ave ssh --delete --progress mock-result-dir/ jskarvad@fedorapeople.org:/home/fedora/jskarvad/public_html/tuned/devel/repo/

html:
	$(MAKE) -C doc/manual

install-html:
	$(MAKE) -C doc/manual install

clean-html:
	$(MAKE) -C doc/manual clean

install-dirs:
	mkdir -p $(DESTDIR)$(PYTHON_SITELIB)
	mkdir -p $(DESTDIR)$(TUNED_PROFILES_DIR)
	mkdir -p $(DESTDIR)/var/lib/tuned
	mkdir -p $(DESTDIR)/var/log/tuned
	mkdir -p $(DESTDIR)/run/tuned
	mkdir -p $(DESTDIR)$(DOCDIR)
	mkdir -p $(DESTDIR)$(SYSCONFDIR)
	mkdir -p $(DESTDIR)$(SYSCONFDIR)/tuned/profiles
	mkdir -p $(DESTDIR)$(TUNED_RECOMMEND_DIR)
	mkdir -p $(DESTDIR)$(TUNED_USER_RECOMMEND_DIR)

install: install-dirs
	# library
	cp -a tuned $(DESTDIR)$(PYTHON_SITELIB)

	# binaries
	$(call install_python_script,tuned.py,$(DESTDIR)/usr/sbin/tuned)
	$(call install_python_script,tuned-adm.py,$(DESTDIR)/usr/sbin/tuned-adm)
	$(call install_python_script,tuned-gui.py,$(DESTDIR)/usr/sbin/tuned-gui)

	$(foreach file, diskdevstat netdevstat scomes, \
		install -Dpm 0755 systemtap/$(file) $(DESTDIR)/usr/sbin/$(notdir $(file));)
	$(call install_python_script, \
		systemtap/varnetload, $(DESTDIR)/usr/sbin/varnetload)

	# glade
	install -Dpm 0644 tuned-gui.glade $(DESTDIR)$(DATADIR)/tuned/ui/tuned-gui.glade

	# tools
	$(call install_python_script, \
		 experiments/powertop2tuned.py, $(DESTDIR)/usr/bin/powertop2tuned)

	# configuration files
	install -Dpm 0644 tuned-main.conf $(DESTDIR)$(SYSCONFDIR)/tuned/tuned-main.conf
	# None profile in the moment, autodetection will be used
	echo -n > $(DESTDIR)$(SYSCONFDIR)/tuned/active_profile
	echo -n > $(DESTDIR)$(SYSCONFDIR)/tuned/profile_mode
	echo -n > $(DESTDIR)$(SYSCONFDIR)/tuned/post_loaded_profile
	install -Dpm 0644 bootcmdline $(DESTDIR)$(SYSCONFDIR)/tuned/bootcmdline
	install -Dpm 0644 modules.conf $(DESTDIR)$(SYSCONFDIR)/modprobe.d/tuned.conf

	# profiles & system config
	cp -a profiles/* $(DESTDIR)$(TUNED_PROFILES_DIR)/
	mv $(DESTDIR)$(TUNED_PROFILES_DIR)/realtime/realtime-variables.conf \
		$(DESTDIR)$(SYSCONFDIR)/tuned/realtime-variables.conf
	mv $(DESTDIR)$(TUNED_PROFILES_DIR)/realtime-virtual-guest/realtime-virtual-guest-variables.conf \
		$(DESTDIR)$(SYSCONFDIR)/tuned/realtime-virtual-guest-variables.conf
	mv $(DESTDIR)$(TUNED_PROFILES_DIR)/realtime-virtual-host/realtime-virtual-host-variables.conf \
		$(DESTDIR)$(SYSCONFDIR)/tuned/realtime-virtual-host-variables.conf
	mv $(DESTDIR)$(TUNED_PROFILES_DIR)/cpu-partitioning/cpu-partitioning-variables.conf \
		$(DESTDIR)$(SYSCONFDIR)/tuned/cpu-partitioning-variables.conf
	mv $(DESTDIR)$(TUNED_PROFILES_DIR)/cpu-partitioning-powersave/cpu-partitioning-powersave-variables.conf \
		$(DESTDIR)$(SYSCONFDIR)/tuned/cpu-partitioning-powersave-variables.conf
	install -pm 0644 recommend.conf $(DESTDIR)$(TUNED_RECOMMEND_DIR)/50-tuned.conf

	# bash functions used by profile scripts
	install -Dpm 0644 functions $(DESTDIR)$(TUNED_SYSTEM_DIR)

	# bash completion
	install -Dpm 0644 tuned-adm.bash $(DESTDIR)$(BASH_COMPLETIONS)/tuned-adm

	# runtime directory
	install -Dpm 0644 tuned.tmpfiles $(DESTDIR)$(TMPFILESDIR)/tuned.conf

	# systemd units
	install -Dpm 0644 tuned.service $(DESTDIR)$(UNITDIR)/tuned.service

	# dbus configuration
	install -Dpm 0644 dbus.conf $(DESTDIR)$(DATADIR)/dbus-1/system.d/com.redhat.tuned.conf

	# grub template
	install -Dpm 0755 00_tuned $(DESTDIR)$(SYSCONFDIR)/grub.d/00_tuned

	# kernel install hook
	install -Dpm 0755 92-tuned.install $(DESTDIR)$(KERNELINSTALLHOOKDIR)/92-tuned.install

	# polkit configuration
	install -Dpm 0644 com.redhat.tuned.policy $(DESTDIR)$(DATADIR)/polkit-1/actions/com.redhat.tuned.policy

	# manual pages
	$(foreach man_section, 5 7 8, $(foreach file, $(wildcard man/*.$(man_section)), \
		install -Dpm 0644 $(file) $(DESTDIR)$(DATADIR)/man/man$(man_section)/$(notdir $(file));))

	# documentation
	cp -a doc/README* $(DESTDIR)$(DOCDIR)
	cp -a doc/*.txt $(DESTDIR)$(DOCDIR)
	cp AUTHORS COPYING README.md $(DESTDIR)$(DOCDIR)

	# libexec scripts
	$(foreach file, $(wildcard libexec/*), \
		$(call install_python_script, \
			$(file), $(DESTDIR)/usr/libexec/tuned/$(notdir $(file))))

	# icon
	install -Dpm 0644 icons/tuned.svg $(DESTDIR)$(DATADIR)/icons/hicolor/scalable/apps/tuned.svg

	# desktop file
	install -dD $(DESTDIR)$(DATADIR)/applications
	desktop-file-install --dir=$(DESTDIR)$(DATADIR)/applications tuned-gui.desktop

install-ppd: install
	$(call install_python_script,tuned-ppd.py,$(DESTDIR)/usr/sbin/tuned-ppd)
	install -Dpm 0644 tuned/ppd/tuned-ppd.service $(DESTDIR)$(UNITDIR)/tuned-ppd.service
	install -Dpm 0644 tuned/ppd/tuned-ppd.dbus.service $(DESTDIR)$(DATADIR)/dbus-1/system-services/net.hadess.PowerProfiles.service
	install -Dpm 0644 tuned/ppd/dbus.conf $(DESTDIR)$(DATADIR)/dbus-1/system.d/net.hadess.PowerProfiles.conf
	install -Dpm 0644 tuned/ppd/tuned-ppd.policy $(DESTDIR)$(DATADIR)/polkit-1/actions/net.hadess.PowerProfiles.policy
	install -Dpm 0644 tuned/ppd/ppd.conf $(DESTDIR)$(SYSCONFDIR)/tuned/ppd.conf

clean: clean-html
	find -name "*.pyc" | xargs rm -f
	rm -rf $(VERSIONED_NAME) rpm-build-dir

test:
	$(PYTHON) -B -m unittest discover tests/unit

lint:
	$(PYLINT) -E -f parseable tuned *.py tests/unit

.PHONY: clean archive srpm tag test lint

=== debian/changelog ===
tuned (2.24.0-1) unstable; urgency=medium

  * migrate profiles to /{etc,usr/lib}/tuned/profiles
  * refresh patches
  * Standards-Version: 4.7.0
  * add NEWS.Debian entry about new profiles folders

 -- Evgeni Golov <evgeni@debian.org>  Tue, 29 Oct 2024 20:39:51 +0100

## tuned 2.24.1

=== Makefile ===
--- 
+++ 
@@ -47,9 +47,11 @@
 endif
 KERNELINSTALLHOOKDIR = /usr/lib/kernel/install.d
 TUNED_SYSTEM_DIR = /usr/lib/tuned
-TUNED_PROFILES_DIR = $(TUNED_SYSTEM_DIR)/profiles
+TUNED_SYSTEM_PROFILES_DIR = $(TUNED_SYSTEM_DIR)/profiles
+TUNED_CFG_DIR = $(SYSCONFDIR)/tuned
+TUNED_USER_PROFILES_DIR = $(TUNED_CFG_DIR)/profiles
 TUNED_RECOMMEND_DIR = $(TUNED_SYSTEM_DIR)/recommend.d
-TUNED_USER_RECOMMEND_DIR = $(SYSCONFDIR)/tuned/recommend.d
+TUNED_USER_RECOMMEND_DIR = $(TUNED_CFG_DIR)/recommend.d
 BASH_COMPLETIONS = $(DATADIR)/bash-completion/completions
 
 copy_executable = install -Dm 0755 $(1) $(2)
@@ -129,13 +131,13 @@
 
 install-dirs:
 	mkdir -p $(DESTDIR)$(PYTHON_SITELIB)
-	mkdir -p $(DESTDIR)$(TUNED_PROFILES_DIR)
+	mkdir -p $(DESTDIR)$(TUNED_SYSTEM_PROFILES_DIR)
 	mkdir -p $(DESTDIR)/var/lib/tuned
 	mkdir -p $(DESTDIR)/var/log/tuned
 	mkdir -p $(DESTDIR)/run/tuned
 	mkdir -p $(DESTDIR)$(DOCDIR)
 	mkdir -p $(DESTDIR)$(SYSCONFDIR)
-	mkdir -p $(DESTDIR)$(SYSCONFDIR)/tuned/profiles
+	mkdir -p $(DESTDIR)$(TUNED_USER_PROFILES_DIR)
 	mkdir -p $(DESTDIR)$(TUNED_RECOMMEND_DIR)
 	mkdir -p $(DESTDIR)$(TUNED_USER_RECOMMEND_DIR)
 
@@ -161,26 +163,36 @@
 		 experiments/powertop2tuned.py, $(DESTDIR)/usr/bin/powertop2tuned)
 
 	# configuration files
-	install -Dpm 0644 tuned-main.conf $(DESTDIR)$(SYSCONFDIR)/tuned/tuned-main.conf
+	# Update default profiles location, in the configuration and in the code
+	sed '/^\s*#\?\s*profile_dirs\s*=\s*/ s|\(profile_dirs\s*=\s*\).*$$|\1$(TUNED_SYSTEM_PROFILES_DIR),$(TUNED_USER_PROFILES_DIR)|' \
+		tuned-main.conf > tuned-main.conf.tmp
+	touch -r tuned-main.conf tuned-main.conf.tmp
+	sed -i '/^\s*USER_PROFILES_DIR\s*=\s*/ s|\(USER_PROFILES_DIR\s*=\s*\).*$$|\1"$(TUNED_USER_PROFILES_DIR)"|' \
+		$(DESTDIR)$(PYTHON_SITELIB)/tuned/consts.py
+	sed -i '/^\s*SYSTEM_PROFILES_DIR\s*=\s*/ s|\(SYSTEM_PROFILES_DIR\s*=\s*\).*$$|\1"$(TUNED_SYSTEM_PROFILES_DIR)"|' \
+		$(DESTDIR)$(PYTHON_SITELIB)/tuned/consts.py
+	install -Dpm 0644 tuned-main.conf.tmp $(DESTDIR)$(TUNED_CFG_DIR)/tuned-main.conf
+	rm -f tuned-main.conf.tmp
+
 	# None profile in the moment, autodetection will be used
-	echo -n > $(DESTDIR)$(SYSCONFDIR)/tuned/active_profile
-	echo -n > $(DESTDIR)$(SYSCONFDIR)/tuned/profile_mode
-	echo -n > $(DESTDIR)$(SYSCONFDIR)/tuned/post_loaded_profile
-	install -Dpm 0644 bootcmdline $(DESTDIR)$(SYSCONFDIR)/tuned/bootcmdline
+	echo -n > $(DESTDIR)$(TUNED_CFG_DIR)/active_profile
+	echo -n > $(DESTDIR)$(TUNED_CFG_DIR)/profile_mode
+	echo -n > $(DESTDIR)$(TUNED_CFG_DIR)/post_loaded_profile
+	install -Dpm 0644 bootcmdline $(DESTDIR)$(TUNED_CFG_DIR)/bootcmdline
 	install -Dpm 0644 modules.conf $(DESTDIR)$(SYSCONFDIR)/modprobe.d/tuned.conf
 
 	# profiles & system config
-	cp -a profiles/* $(DESTDIR)$(TUNED_PROFILES_DIR)/
-	mv $(DESTDIR)$(TUNED_PROFILES_DIR)/realtime/realtime-variables.conf \
-		$(DESTDIR)$(SYSCONFDIR)/tuned/realtime-variables.conf
-	mv $(DESTDIR)$(TUNED_PROFILES_DIR)/realtime-virtual-guest/realtime-virtual-guest-variables.conf \
-		$(DESTDIR)$(SYSCONFDIR)/tuned/realtime-virtual-guest-variables.conf
-	mv $(DESTDIR)$(TUNED_PROFILES_DIR)/realtime-virtual-host/realtime-virtual-host-variables.conf \
-		$(DESTDIR)$(SYSCONFDIR)/tuned/realtime-virtual-host-variables.conf
-	mv $(DESTDIR)$(TUNED_PROFILES_DIR)/cpu-partitioning/cpu-partitioning-variables.conf \
-		$(DESTDIR)$(SYSCONFDIR)/tuned/cpu-partitioning-variables.conf
-	mv $(DESTDIR)$(TUNED_PROFILES_DIR)/cpu-partitioning-powersave/cpu-partitioning-powersave-variables.conf \
-		$(DESTDIR)$(SYSCONFDIR)/tuned/cpu-partitioning-powersave-variables.conf
+	cp -a profiles/* $(DESTDIR)$(TUNED_SYSTEM_PROFILES_DIR)/
+	mv $(DESTDIR)$(TUNED_SYSTEM_PROFILES_DIR)/realtime/realtime-variables.conf \
+		$(DESTDIR)$(TUNED_CFG_DIR)/realtime-variables.conf
+	mv $(DESTDIR)$(TUNED_SYSTEM_PROFILES_DIR)/realtime-virtual-guest/realtime-virtual-guest-variables.conf \
+		$(DESTDIR)$(TUNED_CFG_DIR)/realtime-virtual-guest-variables.conf
+	mv $(DESTDIR)$(TUNED_SYSTEM_PROFILES_DIR)/realtime-virtual-host/realtime-virtual-host-variables.conf \
+		$(DESTDIR)$(TUNED_CFG_DIR)/realtime-virtual-host-variables.conf
+	mv $(DESTDIR)$(TUNED_SYSTEM_PROFILES_DIR)/cpu-partitioning/cpu-partitioning-variables.conf \
+		$(DESTDIR)$(TUNED_CFG_DIR)/cpu-partitioning-variables.conf
+	mv $(DESTDIR)$(TUNED_SYSTEM_PROFILES_DIR)/cpu-partitioning-powersave/cpu-partitioning-powersave-variables.conf \
+		$(DESTDIR)$(TUNED_CFG_DIR)/cpu-partitioning-powersave-variables.conf
 	install -pm 0644 recommend.conf $(DESTDIR)$(TUNED_RECOMMEND_DIR)/50-tuned.conf
 
 	# bash functions used by profile scripts
@@ -228,7 +240,7 @@
 	install -dD $(DESTDIR)$(DATADIR)/applications
 	desktop-file-install --dir=$(DESTDIR)$(DATADIR)/applications tuned-gui.desktop
 
-install-ppd: install
+install-ppd:
 	$(call install_python_script,tuned-ppd.py,$(DESTDIR)/usr/sbin/tuned-ppd)
 	install -Dpm 0644 tuned/ppd/tuned-ppd.service $(DESTDIR)$(UNITDIR)/tuned-ppd.service
 	install -Dpm 0644 tuned/ppd/tuned-ppd.dbus.service $(DESTDIR)$(DATADIR)/dbus-1/system-services/net.hadess.PowerProfiles.service

=== debian/changelog ===
tuned (2.24.1-1ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable (LP: #2092913). Remaining changes:
    - Recommend the default profile for containers:
      + d/p/0004-Recommend-the-default-profile-for-containers.patch:
        apply default profile in containers by default
      + d/t/{control,tuned-container}: check default profile in a container
    - d/t/{control,tuned-vm}: add test to check tuned in a VM
    - d/p/0005-Use-float-instead-of-str-in-cpu-plugin-load-threshol.patch: fix
      error when trying to set CPU latency threshold in a custom profile.
    - d/p/0006-CPU-plugin-log-an-error-when-running-on-s390x.patch:
      notify user that the CPU plugin does not work as expected on
      s390x.
      [Refreshed]
    - Create DEP-8 test for custom profile:
      + d/t/custom-profile: created with content extracted from tuned-vm
        test.  Now expect an error message in the logs when running on
        s390x.
      + d/t/control: add the new custom-profile test.
    - d/t/control: limit test dependencies to only tuned, as tuned-ppd
      changes the default profile to "balanced"
    - Handle a missing python perf module more gracefully (LP #2051290):
      + d/control: suggest linux-tools-common and irqbalance, used by some
        plugins
      + d/p/handle-missing-perf-module.patch: fail more gracefully if the
        python perf module cannot be imported
    - d/t/control: add allow-stderr restriction to the tuned-vm test because
      when the python perf module isn't installed, a log message is written to
      stderr
    - Don't try to tune loop devices (LP #2073007):
      + d/p/disk-plugin-ignore-loop-devices.patch: ignore loop devices
        [Refreshed]
      + d/t/control, d/t/disk-plugin-ignores-loop-devices: new DEP8 test to
        check that tuned is ignoring loop devices
  * Added:
    - d/t/tuned-vm: don't use the postgresql profile due to LP #2092966
    - d/t/custom-profile: profiles now reside in /etc/tuned/profiles
    - d/tuned.postinst: migrate custom profiles from /etc/tuned to
      /etc/tuned/profiles if needed

 -- Andreas Hasenack <andreas@canonical.com>  Thu, 09 Jan 2025 18:06:35 -0300

tuned (2.24.1-1) unstable; urgency=medium

  * New upstream release (Closes: #1088635)
  * fixed privileged execution of arbitrary scripts by active local user
    CVE-2024-52336
  * added sanity checks for API methods parameters
    CVE-2024-52337

 -- Evgeni Golov <evgeni@debian.org>  Wed, 04 Dec 2024 21:07:45 +0100

tuned (2.22.1-1ubuntu4) oracular; urgency=medium

  * Don't try to tune loop devices (LP: #2073007):
    - d/p/disk-plugin-ignore-loop-devices.patch: ignore loop devices
    - d/t/control, d/t/disk-plugin-ignores-loop-devices: new DEP8 test to check
      that tuned is ignoring loop devices

 -- Andreas Hasenack <andreas@canonical.com>  Tue, 03 Sep 2024 14:05:14 -0300

tuned (2.22.1-1ubuntu3) oracular; urgency=medium

  * d/t/control: add allow-stderr restriction to the tuned-vm test because when
    the python perf module isn't installed, a log message is written to stderr

 -- Andreas Hasenack <andreas@canonical.com>  Thu, 22 Aug 2024 19:40:03 -0300

tuned (2.22.1-1ubuntu2) oracular; urgency=medium

  * Handle a missing python perf module more gracefully (LP: #2051290):
    - d/control: suggest linux-tools-common and irqbalance, used by some plugins
    - d/p/handle-missing-perf-module.patch: fail more gracefully if the python
      perf module cannot be imported

 -- Andreas Hasenack <andreas@canonical.com>  Tue, 20 Aug 2024 17:34:44 -0300

=== debian/control ===
Source: tuned
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Evgeni Golov <evgeni@debian.org>
Build-Depends: asciidoctor,
               debhelper-compat (= 13),
               desktop-file-utils,
               dh-python,
               ethtool,
               hdparm,
               pkgconf,
               python3-all,
               python3-dbus,
               python3-gi,
               python3-pyudev,
               systemd-dev,
Standards-Version: 4.7.0
Homepage: https://tuned-project.org/
Vcs-Git: https://salsa.debian.org/debian/tuned.git
Vcs-Browser: https://salsa.debian.org/debian/tuned

Package: tuned
Architecture: all
Depends: dbus,
         ethtool,
         gawk,
         polkitd,
         procps,
         python3-dbus,
         python3-linux-procfs,
         python3-gi,
         python3-pyudev,
         virt-what,
         ${misc:Depends},
         ${python3:Depends}
Recommends: linux-cpupower, linux-perf, dmidecode, hdparm, iproute2, kmod
Suggests: linux-tools-common, irqbalance
Description: daemon for monitoring and adaptive tuning of system devices
 The tuned package contains a daemon that tunes system settings dynamically.
 It does so by monitoring the usage of several system components periodically.
 Based on that information components will then be put into lower or higher
 power saving modes to adapt to the current usage. Currently only ethernet
 network and ATA harddisk devices are implemented.

Package: tuned-gtk
Architecture: all
Depends: gir1.2-gtk-3.0,
         pkexec,
         powertop,
         python3-gi,
         tuned (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends}
Replaces: tuned (<< 2.20.0-1~)
Description: GTK+ GUI for tuned
 The tuned package contains a daemon that tunes system settings dynamically.
 It does so by monitoring the usage of several system components periodically.
 Based on that information components will then be put into lower or higher
 power saving modes to adapt to the current usage. Currently only ethernet
 network and ATA harddisk devices are implemented.
 .
 This package contains the GTK+ GUI that can control tuned and provides simple
 profile editor.

Package: tuned-ppd
Architecture: all
Depends: tuned (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends}
Conflicts: power-profiles-daemon
Provides: power-profiles-daemon
Description: PPD compatibility daemon
 An API translation daemon that allows applications to easily transition
 to TuneD from power-profiles-daemon (PPD).

Package: tuned-utils
Architecture: all
Depends: powertop,
         tuned (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends}
Description: various tuned utilities
 The tuned package contains a daemon that tunes system settings dynamically.
 It does so by monitoring the usage of several system components periodically.
 Based on that information components will then be put into lower or higher
 power saving modes to adapt to the current usage. Currently only ethernet
 network and ATA harddisk devices are implemented.
 .
 This package contains utilities that can help you to fine tune and
 debug your system and manage tuned profiles.

Package: tuned-utils-systemtap
Architecture: all
Depends: systemtap,
         tuned (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends}
Description: disk and net statistic monitoring systemtap scripts
 The tuned package contains a daemon that tunes system settings dynamically.
 It does so by monitoring the usage of several system components periodically.
 Based on that information components will then be put into lower or higher
 power saving modes to adapt to the current usage. Currently only ethernet
 network and ATA harddisk devices are implemented.
 .
 This package contains several systemtap scripts to allow detailed
 manual monitoring of the system. Instead of the typical IO/sec it collects
 minimal, maximal and average time between operations to be able to
 identify applications that behave power inefficient (many small operations
 instead of fewer large ones).

=== debian/tests/control ===
Tests: tuned-adm
Restrictions: isolation-container, needs-root
Depends: tuned

Tests: tuned-container
Restrictions: isolation-container, needs-root, skippable
Depends: tuned

Tests: tuned-vm
# allow-stderr because the missing python3-perf module causes a log message
# to be printed to stderr since LP: #2051290, and that module can't be listed
# as a dependency here because it comes from linux-tools-$(uname -r), i.e., its
# name varies according to the running kernel.
Restrictions: isolation-machine, needs-root, allow-stderr
Depends: tuned

Tests: custom-profile
Restrictions: isolation-machine, needs-root
Depends: tuned

# to test LP: #2073007
Tests: disk-plugin-ignores-loop-devices
Restrictions: isolation-machine, needs-root
Depends: tuned

## tuned 2.25.1

=== debian/changelog ===
tuned (2.25.1-1ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2115749, LP: #2103658). Remaining changes:
    - d/t/{control,tuned-vm}: add test to check tuned in a VM
    - d/p/0005-Use-float-instead-of-str-in-cpu-plugin-load-threshol.patch: fix
      error when trying to set CPU latency threshold in a custom profile.
    - d/p/0006-CPU-plugin-log-an-error-when-running-on-s390x.patch:
      notify user that the CPU plugin does not work as expected on
      s390x.
    - Create DEP-8 test for custom profile:
      + d/t/custom-profile: created with content extracted from tuned-vm
        test.  Now expect an error message in the logs when running on
        s390x.
      + d/t/control: add the new custom-profile test.
    - d/t/control: limit test dependencies to only tuned, as tuned-ppd
      changes the default profile to "balanced"
    - Handle a missing python perf module more gracefully (LP #2051290):
      + d/control: suggest irqbalance, used by some plugins (and it needs the
        perf module)
      + d/p/handle-missing-perf-module.patch: fail more gracefully if the
        python perf module cannot be imported
        [Refreshed, and updated to only patch the irqbalancer plugin]
    - d/t/control: add allow-stderr restriction to the tuned-vm test because
      when the python perf module isn't installed, a log message is written to
      stderr
    - Don't try to tune loop devices (LP #2073007):
      + d/p/disk-plugin-ignore-loop-devices.patch: ignore loop devices
        [Refreshed]
      + d/t/control, d/t/disk-plugin-ignores-loop-devices: new DEP8 test to
        check that tuned is ignoring loop devices
    - d/t/tuned-vm: don't use the postgresql profile due to LP #2092966
    - d/t/custom-profile: profiles now reside in /etc/tuned/profiles
  * Dropped:
    - Recommend the default profile for containers:
      + d/p/0004-Recommend-the-default-profile-for-containers.patch:
        apply default profile in containers by default
        [In 2.25.1-1]
      + d/t/{control,tuned-container}: check default profile in a container
        [In 2.25.1-1]
    - d/tuned.postinst: migrate custom profiles from /etc/tuned to
      /etc/tuned/profiles if needed
      [In 2.25.1-1]
  * Added:
    - d/control: build-dep on linux-perf, or else the documentation for
      plugins that require linux-perf won't be built

 -- Andreas Hasenack <andreas@canonical.com>  Wed, 23 Jul 2025 10:22:09 -0300

tuned (2.25.1-1) unstable; urgency=medium

  * New upstream release (Closes: #1094790)
  * Support the new UPower PPD namespace (Closes: #1100608)
  * Depend on python3-pyinotify

 -- Evgeni Golov <evgeni@debian.org>  Tue, 01 Apr 2025 21:43:33 +0200

=== debian/control ===
--- 
+++ 
@@ -9,6 +9,7 @@
                dh-python,
                ethtool,
                hdparm,
+               linux-perf,
                pkgconf,
                python3-all,
                python3-dbus,
@@ -35,7 +36,7 @@
          ${misc:Depends},
          ${python3:Depends}
 Recommends: linux-cpupower, linux-perf, dmidecode, hdparm, iproute2, kmod
-Suggests: linux-tools-common, irqbalance
+Suggests: irqbalance
 Description: daemon for monitoring and adaptive tuning of system devices
  The tuned package contains a daemon that tunes system settings dynamically.
  It does so by monitoring the usage of several system components periodically.
@@ -66,6 +67,7 @@
 Package: tuned-ppd
 Architecture: all
 Depends: tuned (= ${binary:Version}),
+         python3-pyinotify,
          ${misc:Depends},
          ${python3:Depends}
 Conflicts: power-profiles-daemon

=== debian/tests/control ===
--- 
+++ 
@@ -3,7 +3,10 @@
 Depends: tuned
 
 Tests: tuned-container
-Restrictions: isolation-container, needs-root, skippable
+Restrictions: isolation-container, needs-root, skippable, allow-stderr
+# Don't install tuned-ppd specifically, as that changes the default profile
+# to balanced, and in this test we want to verify that the default profile
+# is "default" instead
 Depends: tuned
 
 Tests: tuned-vm

## tuned 2.26.0

=== Makefile ===
--- 
+++ 
@@ -32,27 +32,32 @@
 TMPFILESDIR = $(TMPFILESDIR_DETECT:%{_tmpfilesdir}=$(TMPFILESDIR_FALLBACK))
 VERSIONED_NAME = $(NAME)-$(VERSION)$(PRERELEASE)$(GIT_PSUFFIX)
 
+export PREFIX = /usr
+export BINDIR = $(PREFIX)/bin
+export SBINDIR = $(PREFIX)/sbin
 export SYSCONFDIR = /etc
-export DATADIR = /usr/share
+export LIBEXECDIR = $(PREFIX)/libexec
+export DATADIR = $(PREFIX)/share
 export DOCDIR = $(DATADIR)/doc/$(NAME)
-PYTHON = /usr/bin/python3
+export PYTHON = $(BINDIR)/python3
 PYLINT = pylint-3
 ifeq ($(PYTHON),python2)
 PYLINT = pylint-2
 endif
-SHEBANG_REWRITE_REGEX= '1s|^\#!/usr/bin/\<python3\>|\#!$(PYTHON)|'
+SHEBANG_REWRITE_REGEX= '1s|^\#!$(BINDIR)/\<python3\>|\#!$(PYTHON)|'
 PYTHON_SITELIB = $(shell $(PYTHON) -c 'from sysconfig import get_path; print(get_path("purelib"));')
 ifeq ($(PYTHON_SITELIB),)
 $(error Failed to determine python library directory)
 endif
-KERNELINSTALLHOOKDIR = /usr/lib/kernel/install.d
-TUNED_SYSTEM_DIR = /usr/lib/tuned
+KERNELINSTALLHOOKDIR = $(PREFIX)/lib/kernel/install.d
+TUNED_SYSTEM_DIR = $(PREFIX)/lib/tuned
 TUNED_SYSTEM_PROFILES_DIR = $(TUNED_SYSTEM_DIR)/profiles
 TUNED_CFG_DIR = $(SYSCONFDIR)/tuned
 TUNED_USER_PROFILES_DIR = $(TUNED_CFG_DIR)/profiles
 TUNED_RECOMMEND_DIR = $(TUNED_SYSTEM_DIR)/recommend.d
 TUNED_USER_RECOMMEND_DIR = $(TUNED_CFG_DIR)/recommend.d
 BASH_COMPLETIONS = $(DATADIR)/bash-completion/completions
+PPD_BUS_NAMES = org.freedesktop.UPower.PowerProfiles net.hadess.PowerProfiles
 
 copy_executable = install -Dm 0755 $(1) $(2)
 rewrite_shebang = sed -i -r -e $(SHEBANG_REWRITE_REGEX) $(1)
@@ -70,7 +75,7 @@
 		tuned-adm.bash dbus.conf recommend.conf tuned-main.conf 00_tuned \
 		92-tuned.install bootcmdline modules.conf com.redhat.tuned.policy \
 		tuned-gui.py tuned-gui.glade tuned-ppd.py \
-		tuned-gui.desktop functions $(VERSIONED_NAME)
+		tuned-gui.desktop functions compile_plugin_docs.py $(VERSIONED_NAME)
 	cp -a doc experiments libexec man profiles systemtap tuned contrib icons \
 		tests $(VERSIONED_NAME)
 
@@ -146,21 +151,21 @@
 	cp -a tuned $(DESTDIR)$(PYTHON_SITELIB)
 
 	# binaries
-	$(call install_python_script,tuned.py,$(DESTDIR)/usr/sbin/tuned)
-	$(call install_python_script,tuned-adm.py,$(DESTDIR)/usr/sbin/tuned-adm)
-	$(call install_python_script,tuned-gui.py,$(DESTDIR)/usr/sbin/tuned-gui)
+	$(call install_python_script,tuned.py,$(DESTDIR)$(SBINDIR)/tuned)
+	$(call install_python_script,tuned-adm.py,$(DESTDIR)$(SBINDIR)/tuned-adm)
+	$(call install_python_script,tuned-gui.py,$(DESTDIR)$(SBINDIR)/tuned-gui)
 
 	$(foreach file, diskdevstat netdevstat scomes, \
-		install -Dpm 0755 systemtap/$(file) $(DESTDIR)/usr/sbin/$(notdir $(file));)
+		install -Dpm 0755 systemtap/$(file) $(DESTDIR)$(SBINDIR)/$(notdir $(file));)
 	$(call install_python_script, \
-		systemtap/varnetload, $(DESTDIR)/usr/sbin/varnetload)
+		systemtap/varnetload, $(DESTDIR)$(SBINDIR)/varnetload)
 
 	# glade
 	install -Dpm 0644 tuned-gui.glade $(DESTDIR)$(DATADIR)/tuned/ui/tuned-gui.glade
 
 	# tools
 	$(call install_python_script, \
-		 experiments/powertop2tuned.py, $(DESTDIR)/usr/bin/powertop2tuned)
+		 experiments/powertop2tuned.py, $(DESTDIR)$(BINDIR)/powertop2tuned)
 
 	# configuration files
 	# Update default profiles location, in the configuration and in the code
@@ -178,6 +183,7 @@
 	echo -n > $(DESTDIR)$(TUNED_CFG_DIR)/active_profile
 	echo -n > $(DESTDIR)$(TUNED_CFG_DIR)/profile_mode
 	echo -n > $(DESTDIR)$(TUNED_CFG_DIR)/post_loaded_profile
+	echo -n > $(DESTDIR)$(TUNED_CFG_DIR)/ppd_base_profile
 	install -Dpm 0644 bootcmdline $(DESTDIR)$(TUNED_CFG_DIR)/bootcmdline
 	install -Dpm 0644 modules.conf $(DESTDIR)$(SYSCONFDIR)/modprobe.d/tuned.conf
 
@@ -231,7 +237,7 @@
 	# libexec scripts
 	$(foreach file, $(wildcard libexec/*), \
 		$(call install_python_script, \
-			$(file), $(DESTDIR)/usr/libexec/tuned/$(notdir $(file))))
+			$(file), $(DESTDIR)$(LIBEXECDIR)/tuned/$(notdir $(file))))
 
 	# icon
 	install -Dpm 0644 icons/tuned.svg $(DESTDIR)$(DATADIR)/icons/hicolor/scalable/apps/tuned.svg
@@ -241,12 +247,16 @@
 	desktop-file-install --dir=$(DESTDIR)$(DATADIR)/applications tuned-gui.desktop
 
 install-ppd:
-	$(call install_python_script,tuned-ppd.py,$(DESTDIR)/usr/sbin/tuned-ppd)
+	$(call install_python_script,tuned-ppd.py,$(DESTDIR)$(SBINDIR)/tuned-ppd)
 	install -Dpm 0644 tuned/ppd/tuned-ppd.service $(DESTDIR)$(UNITDIR)/tuned-ppd.service
-	install -Dpm 0644 tuned/ppd/tuned-ppd.dbus.service $(DESTDIR)$(DATADIR)/dbus-1/system-services/net.hadess.PowerProfiles.service
-	install -Dpm 0644 tuned/ppd/dbus.conf $(DESTDIR)$(DATADIR)/dbus-1/system.d/net.hadess.PowerProfiles.conf
-	install -Dpm 0644 tuned/ppd/tuned-ppd.policy $(DESTDIR)$(DATADIR)/polkit-1/actions/net.hadess.PowerProfiles.policy
 	install -Dpm 0644 tuned/ppd/ppd.conf $(DESTDIR)$(SYSCONFDIR)/tuned/ppd.conf
+	$(foreach bus, $(PPD_BUS_NAMES), \
+		install -Dpm 0644 tuned/ppd/tuned-ppd.dbus.service $(DESTDIR)$(DATADIR)/dbus-1/system-services/$(bus).service; \
+		sed -i 's/?name?/$(bus)/g' $(DESTDIR)$(DATADIR)/dbus-1/system-services/$(bus).service; \
+		install -Dpm 0644 tuned/ppd/dbus.conf $(DESTDIR)$(DATADIR)/dbus-1/system.d/$(bus).conf; \
+		sed -i 's/?name?/$(bus)/g' $(DESTDIR)$(DATADIR)/dbus-1/system.d/$(bus).conf; \
+		install -Dpm 0644 tuned/ppd/tuned-ppd.policy $(DESTDIR)$(DATADIR)/polkit-1/actions/$(bus).policy; \
+		sed -i 's/?name?/$(bus)/g' $(DESTDIR)$(DATADIR)/polkit-1/actions/$(bus).policy;)
 
 clean: clean-html
 	find -name "*.pyc" | xargs rm -f

=== doc/manual/Makefile ===
.PHONY: clean

index.html: master.adoc assemblies/*.adoc meta/*.adoc modules/performance/*.adoc ../../tuned/plugins/plugin_*.py
	$(PYTHON) ../../compile_plugin_docs.py modules/performance/ref_available-tuned-plug-ins_intro.adoc modules/performance/ref_available-tuned-plug-ins.adoc
	asciidoctor -o index.html master.adoc || asciidoc -d book -o index.html master.adoc

install: index.html
	install -Dpm 0644 index.html $(DESTDIR)$(DOCDIR)/manual/index.html

clean:
	rm -f modules/performance/ref_available-tuned-plug-ins.adoc
	rm -f *.html

=== debian/changelog ===
tuned (2.26.0-1) unstable; urgency=medium

  [ Evgeni Golov ]
  * New upstream release
  * mark patches as forwarded if they were
  * Standards-Version: 4.7.2

  [ Andreas Hasenack ]
  * d/control: add build-dep on linux-perf to include irqbalance docs
    (Closes: #1109771)

 -- Evgeni Golov <evgeni@debian.org>  Thu, 11 Sep 2025 19:17:28 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: tuned
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Evgeni Golov <evgeni@debian.org>
+Maintainer: Evgeni Golov <evgeni@debian.org>
 Build-Depends: asciidoctor,
                debhelper-compat (= 13),
                desktop-file-utils,
@@ -16,7 +15,7 @@
                python3-gi,
                python3-pyudev,
                systemd-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://tuned-project.org/
 Vcs-Git: https://salsa.debian.org/debian/tuned.git
 Vcs-Browser: https://salsa.debian.org/debian/tuned
@@ -36,7 +35,6 @@
          ${misc:Depends},
          ${python3:Depends}
 Recommends: linux-cpupower, linux-perf, dmidecode, hdparm, iproute2, kmod
-Suggests: irqbalance
 Description: daemon for monitoring and adaptive tuning of system devices
  The tuned package contains a daemon that tunes system settings dynamically.
  It does so by monitoring the usage of several system components periodically.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export DEB_PYTHON_INSTALL_LAYOUT=deb_system
export deb_systemdsystemunitdir = $(shell pkg-config --variable=systemdsystemunitdir systemd | sed s,^/,,)

%:
	dh $@ --with python3

execute_after_dh_auto_build:
	make html

execute_before_dh_install:
	make install-html DESTDIR=$(CURDIR)/debian/tmp
	make install-ppd DESTDIR=$(CURDIR)/debian/tmp

=== debian/tests/control ===
Tests: tuned-adm
Restrictions: isolation-container, needs-root
Depends: @

Tests: tuned-container
Restrictions: isolation-container, needs-root, skippable, allow-stderr
# Don't install tuned-ppd specifically, as that changes the default profile
# to balanced, and in this test we want to verify that the default profile
# is "default" instead
Depends: tuned

## tuned 2.27.0

=== debian/changelog ===
tuned (2.27.0-1) unstable; urgency=medium

  * New upstream release
  * Depend on "default-dbus-system-bus | dbus-system-bus" (Closes: #1122731)

 -- Evgeni Golov <evgeni@debian.org>  Mon, 02 Mar 2026 20:07:11 +0100

=== debian/control ===
--- 
+++ 
@@ -22,7 +22,7 @@
 
 Package: tuned
 Architecture: all
-Depends: dbus,
+Depends: default-dbus-system-bus | dbus-system-bus,
          ethtool,
          gawk,
          polkitd,
